chrome.extension.onConnect.addListener(function (PORT) {
    PORT.onMessage.addListener(function () {
        PORT.postMessage(location.hostname);
    });
})


chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
    if (request.type === "script-is-exist") {
        const script = request.options.message;
        chrome.runtime.sendMessage({
            msg: "script-is-exist",
            data: script
        });
    }

    if (request.action === "updateIcon") {
        if (request.value === false) {
            chrome.browserAction.setIcon({path: "/images/icon.png"});
        } else {
            chrome.browserAction.setIcon({path: "/images/icon-active.png"});
        }
    }

    sendResponse();
});

chrome.tabs.onActivated.addListener(function(activeInfo) {
    chrome.tabs.get(activeInfo.tabId, function(tab){
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs){
            chrome.tabs.sendMessage(tabs[0].id, {'method': 'icon-state-checker'}, function(response) {
                if (!response) {
                    chrome.browserAction.setIcon({path: "/images/icon.png"});
                } else {
                    chrome.browserAction.setIcon({path: "/images/icon-active.png"});
                }
            });
        });
    });
});

chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
    if (request.options.type === "icon-state-checker") {
        if (!request.options.state) {
            chrome.browserAction.setIcon({path: "/images/icon.png"});
        } else {
            chrome.browserAction.setIcon({path: "/images/icon-active.png"});
        }
    }
});
