const addButton = document.getElementById('addButton');
const deleteButton = document.getElementById('deleteButton');
const scriptToAdd = document.getElementById('scriptToAdd');
const youCanAddScriptText = document.getElementById('youCanAddScriptText');
const youAlreadyAddScriptText = document.getElementById('youAlreadyAddScriptText');
const youCanAddScriptIcon = document.getElementById('youCanAddScriptIcon');
const youAlreadyAddScriptIcon = document.getElementById('youAlreadyAddScriptIcon');
let scriptToAddIsMissing = true;
let url;

updateAddButtonState(scriptToAddIsMissing);
updateDeleteButtonState(true);

addButton.addEventListener("click", async () => {
    if (!scriptToAddIsMissing) {
        const scriptText = scriptToAdd.value;

        chrome.tabs.query({active: true, currentWindow: true}, function (tabs) {
            chrome.tabs.sendMessage(tabs[0].id, {todo: "addScript", scriptText}, function (response) {})
        });
        updateDeleteButtonState(false);
        toggleText(true);
        updateAddButtonState(true);
    }
});
deleteButton.addEventListener("click", async () => {
    chrome.tabs.query({active: true, currentWindow: true}, function (tabs) {
        chrome.tabs.sendMessage(tabs[0].id, {todo: "deleteScript"}, function (response) {})
    });
    toggleText(false);
    scriptToAdd.value = "";
    updateDeleteButtonState(true);
});

scriptToAdd.addEventListener("input", async () => {
    scriptToAdd.value.trim() ? scriptToAddIsMissing = false : scriptToAddIsMissing = true;
    updateAddButtonState(scriptToAddIsMissing);
})

function updateAddButtonState(state) {
    state ? addButton.classList.add('disabled') : addButton.classList.remove('disabled');
}

function updateDeleteButtonState(state) {
    state ? deleteButton.classList.add('disabled') : deleteButton.classList.remove('disabled');
}

function setupURL(url) {
    document.getElementById('website-url').innerText = url;
}

function toggleText(state) {
    if (state) {
        youCanAddScriptText.classList.remove('active');
        youCanAddScriptIcon.classList.remove('active');
        youAlreadyAddScriptText.classList.add('active');
        youAlreadyAddScriptIcon.classList.add('active');
        return;
    }
    youCanAddScriptText.classList.add('active');
    youCanAddScriptIcon.classList.add('active');
    youAlreadyAddScriptText.classList.remove('active');
    youAlreadyAddScriptIcon.classList.remove('active');
    return;
}

const PORT = chrome.extension.connect({
    name: "Sample Communication"
});
PORT.postMessage("");

chrome.tabs.query({active: true, lastFocusedWindow: true}, tabs => {
    // url = tabs[0].url.replace(/^https?:\/\//, '')
    url = tabs[0].url.match(/^https?\:\/\/([^\/?#]+)(?:[\/?#]|$)/i, "")[1]
    setupURL(url);
});

window.addEventListener('DOMContentLoaded', () => {
    chrome.tabs.query({
        active: true,
        currentWindow: true
    }, tabs => {
        chrome.tabs.sendMessage(
            tabs[0].id,
            {from: 'popup', subject: 'scriptIsExist'}, function (response) {
                if (response) {
                    toggleText(true);
                    updateDeleteButtonState(false);
                    scriptToAdd.textContent = response;
                } else {
                    updateDeleteButtonState(true);
                }
            });
    });
});

